﻿Imports System.Runtime.InteropServices

Public Class Form1
   Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
      ' einfacher Aufruf einer Prozedur
      Dll.TestFunction()
   End Sub

   Private Sub TextBox1_KeyDown(sender As System.Object, e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
      ' nur Ziffern zulassen
      Select Case (e.KeyCode)
         Case Keys.D0 To Keys.D9, Keys.Back, Keys.Left, Keys.Right
         Case Else
            e.SuppressKeyPress = True
      End Select
   End Sub

   Private Sub btnSet_Click(sender As System.Object, e As System.EventArgs) Handles btnSet.Click
      ' Übergabe einer beliebigen Integer-Zahl
      Dim value As Integer
      Dim success As Boolean = False
      If Integer.TryParse(TextBox1.Text, value) Then
         success = Dll.SetValue(value) <> 0
      End If
      LabelSet.Text = success.ToString
   End Sub

   Private Sub btnGet_Click(sender As System.Object, e As System.EventArgs) Handles btnGet.Click
      ' Auslesen einer Integer-Zahl
      Dim i As Integer = 0
      Dim ip As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(i))
      Dll.GetValue(ip)
      i = Marshal.ReadInt32(ip)
      Marshal.FreeHGlobal(ip)
      LabelGet.Text = i.ToString
   End Sub

   Private Sub btnSetN_Click(sender As System.Object, e As System.EventArgs) Handles btnSetN.Click
      ' Übergabe eines Integer-Arrays
      Dim success As Boolean = False
      Dim ar() As Integer = {1, 2, 3, 4, 5, 6, 7, 8}
      Dim i As Integer = 0
      Dim ip As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(i) * ar.Length)
      For i = 0 To ar.Length - 1
         Marshal.WriteInt32(ip, 4 * i, ar(i))
      Next
      success = Dll.SetValues(ip, ar.Length) <> 0
      Marshal.FreeHGlobal(ip)
      LabelSetN.Text = success.ToString
   End Sub

   Private Sub btnGetN_Click(sender As System.Object, e As System.EventArgs) Handles btnGetN.Click
      ' Auslesen des Integer-Arrays
      Dim success As Boolean = False
      Const length As Integer = 10
      Dim ar(length - 1) As Integer
      Dim i As Integer = 0
      Dim txt As String = ""
      Dim ip As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(i) * length)
      success = Dll.GetValues(ip, length) <> 0
      LabelGetN.Text = success.ToString
      If success Then
         For i = 0 To ar.Length - 1
            ar(i) = Marshal.ReadInt32(ip, 4 * i)
            txt &= ar(i).ToString & " "
         Next
         LabelGetN.Text = txt
      End If
      Marshal.FreeHGlobal(ip)
   End Sub

   Private Sub btnSetString1_Click(sender As System.Object, e As System.EventArgs) Handles btnSetString1.Click
      ' Übergabe eines ANSI-Strings
      Dim success As Boolean = False
      Dim txt As String = TextBox2.Text
      Dim p1 As IntPtr = Marshal.StringToHGlobalAnsi(txt)
      success = Dll.SetStringAnsi(p1) <> 0
      LabelSetString1.Text = success.ToString
   End Sub

   Private Sub btnGetString1_Click(sender As System.Object, e As System.EventArgs) Handles btnGetString1.Click
      ' Auslesen eines ANSI-Strings
      Dim success As Boolean = False
      Dim txt As String = ""
      Dim p1 As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(IntPtr.Zero))
      success = Dll.GetStringAnsi(p1) <> 0
      LabelGetString1.Text = success.ToString
      If success Then
         Dim p0 As IntPtr
         p0 = Marshal.ReadIntPtr(p1)
         txt = Marshal.PtrToStringAnsi(p0)
         LabelGetString1.Text = txt
      End If
   End Sub

   Private Sub btnSetString2_Click(sender As System.Object, e As System.EventArgs) Handles btnSetString2.Click
      ' Übergabe eines Unicode-Strings
      Dim success As Boolean = False
      Dim txt As String = TextBox3.Text
      Dim p1 As IntPtr = Marshal.StringToHGlobalUni(txt)
      success = Dll.SetStringUnicode(p1) <> 0
      LabelSetString2.Text = success.ToString
   End Sub

   Private Sub btnGetString2_Click(sender As System.Object, e As System.EventArgs) Handles btnGetString2.Click
      ' Auslesen eines Unicode-Strings
      Dim success As Boolean = False
      Dim txt As String = ""
      Dim p1 As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(IntPtr.Zero))
      success = Dll.GetStringUnicode(p1) <> 0
      LabelGetString2.Text = success.ToString
      If success Then
         Dim p0 As IntPtr
         p0 = Marshal.ReadIntPtr(p1)
         txt = Marshal.PtrToStringUni(p0)
         LabelGetString2.Text = txt
      End If
   End Sub
End Class
